
#property indicator_chart_window

extern int     X.Offset    = 0;
extern int     Y.Offset    = 16;
extern int     DAYS        = 10;
extern int     Font_Size   = 10;
extern color   Title_Color = DeepSkyBlue;
extern color   Value_Color = White;
extern int     Window      = 0;

double ATR_TDay_0;
double ATR_YDay_0;
double ATR_XDay_0;
double ATR_XTotal;
double PP_XTotal;

double PipShift;
double Trend_Range_Ratio;

string prefix = "ADTR_PP";
string name;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   return(0);
}
int deinit()
{
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
   {
       string label = ObjectName(i);
       if(StringSubstr(label, 0, 7) == prefix)
          ObjectDelete(label);   
   }
   return(0);
}


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
   
   int i;
      
   ATR_TDay_0=(iHigh(Symbol(),1440,0) - iLow(Symbol(),1440,0));
   ATR_YDay_0=(iHigh(Symbol(),1440,1) - iLow(Symbol(),1440,1));

   ATR_XTotal=0;
   for (i=1;i<=DAYS;i++)
   {
     ATR_XTotal=ATR_XTotal+(iHigh(Symbol(),1440,i) - iLow(Symbol(),1440,i));
   }
   
   PP_XTotal=0;
   for (i=1;i<=DAYS*24*12;i++)
   {
     PP_XTotal=PP_XTotal+MathAbs(iHigh(Symbol(),5,i)-iLow(Symbol(),5,i));
   }
   
   ATR_XTotal = ATR_XTotal/(DAYS);
   PP_XTotal = PP_XTotal/(DAYS);
   
   PipShift=(iClose(Symbol(),1440,0) - iClose(Symbol(),1440,DAYS))/Point;
   if (PipShift==0)  PipShift=1;
   Trend_Range_Ratio=(PipShift/PP_XTotal)*(ATR_XTotal/PP_XTotal);

   name = prefix +"Todays_Pips_Title";    objectCreate(name,"Today         ATR"                            ,X.Offset    ,Y.Offset   ,Title_Color);
   name = prefix +"Todays_Pips_Value";    objectCreate(name,DoubleToStr(ATR_TDay_0/Point,0)+" Pips"        ,X.Offset+120,Y.Offset   ,Value_Color);
   name = prefix +"Yesterday_Pips_Title"; objectCreate(name,"Yesterday   ATR"                              ,X.Offset    ,Y.Offset+14,Title_Color);
   name = prefix +"Yesterday_Pips_Value"; objectCreate(name,DoubleToStr(ATR_YDay_0/Point,0)+" Pips"        ,X.Offset+120,Y.Offset+14,Value_Color);
   name = prefix +"ATDR_Title";           objectCreate(name,DAYS+" Days Av. ATR"                           ,X.Offset    ,Y.Offset+30,Title_Color);
   name = prefix +"ADTR_Value";           objectCreate(name,DoubleToStr(ATR_XTotal/Point,0)+" Pips"        ,X.Offset+120,Y.Offset+30,Value_Color);
   name = prefix +"PP_Title";             objectCreate(name,"Pip Power"                                    ,X.Offset+192,Y.Offset+30,Title_Color);
   name = prefix +"PP_Value";             objectCreate(name,DoubleToStr(PP_XTotal/Point,0)+" Pips"         ,X.Offset+272,Y.Offset+30,Value_Color);
   name = prefix +"TrendRatio";           objectCreate(name,DAYS+" Days Trend %"                           ,X.Offset    ,Y.Offset+46,Title_Color);
   name = prefix +"TrendRatio_Value";     objectCreate(name,DoubleToStr(Trend_Range_Ratio*Point*100,3)+" %",X.Offset+120,Y.Offset+46,Value_Color);
     
   return(0);
}
  
  
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+  

void objectCreate(string name,string text,int x,int y,color theColor)
{
   if (Window > (WindowsTotal()-1))
       Window = (WindowsTotal()-1);

   ObjectDelete(name);
   ObjectCreate(name, OBJ_LABEL, Window, 0, 0);
     ObjectSetText(name,text,Font_Size, "Arial Bold", theColor);
     ObjectSet(name, OBJPROP_CORNER,0);
     ObjectSet(name, OBJPROP_XDISTANCE, x);
     ObjectSet(name, OBJPROP_YDISTANCE, y); 
   
}