//based on Bands.mq4 indicator created by MetaQuotes Software Corp.
//modified by U.D.C., udc@seznam.cz

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 SkyBlue
#property indicator_color2 SkyBlue
#property indicator_color3 RoyalBlue
#property indicator_color4 RoyalBlue
#property indicator_color5 DodgerBlue
#property indicator_color6 DodgerBlue
#property indicator_color7 SkyBlue
#property indicator_color8 SkyBlue
//---- indicator parameters
extern int    BandsPeriod=20;
extern int    BandsShift=0;
extern double FibNumber1=1.618;
extern double FibNumber2=2.618;
extern double FibNumber3=4.236;
extern double FibNumber4=6.854;
//---- buffers
double UpperBuffer1[];
double LowerBuffer1[];
double UpperBuffer2[];
double LowerBuffer2[];
double UpperBuffer3[];
double LowerBuffer3[];
double UpperBuffer4[];
double LowerBuffer4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(0,UpperBuffer1);
   SetIndexStyle(1,DRAW_LINE, STYLE_DOT, 1);
   SetIndexBuffer(1,LowerBuffer1);
   SetIndexStyle(2,DRAW_LINE, STYLE_SOLID, 1);
   SetIndexBuffer(2,UpperBuffer2);
   SetIndexStyle(3,DRAW_LINE, STYLE_SOLID, 1);
   SetIndexBuffer(3,LowerBuffer2);
   SetIndexStyle(4,DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(4,UpperBuffer3);
   SetIndexStyle(5,DRAW_LINE, STYLE_SOLID, 2);
   SetIndexBuffer(5,LowerBuffer3);
   SetIndexStyle(6,DRAW_LINE, STYLE_SOLID, 3);
   SetIndexBuffer(6,UpperBuffer4);
   SetIndexStyle(7,DRAW_LINE, STYLE_SOLID, 3);
   SetIndexBuffer(7,LowerBuffer4);
//----
   SetIndexDrawBegin(0,BandsPeriod+BandsShift);
   SetIndexDrawBegin(1,BandsPeriod+BandsShift);
   SetIndexDrawBegin(2,BandsPeriod+BandsShift);
   SetIndexDrawBegin(3,BandsPeriod+BandsShift);
   SetIndexDrawBegin(4,BandsPeriod+BandsShift);
   SetIndexDrawBegin(5,BandsPeriod+BandsShift);
   SetIndexDrawBegin(6,BandsPeriod+BandsShift);
   SetIndexDrawBegin(7,BandsPeriod+BandsShift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double deviation1, deviation2, deviation3, deviation4;
   double MovingBuffer[], ATRtemp[], ATR[];
//----
   if(Bars<=BandsPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=BandsPeriod;i++)
        {
         UpperBuffer1[Bars-i]=EMPTY_VALUE;
         LowerBuffer1[Bars-i]=EMPTY_VALUE;
         UpperBuffer2[Bars-i]=EMPTY_VALUE;
         LowerBuffer2[Bars-i]=EMPTY_VALUE;
         UpperBuffer3[Bars-i]=EMPTY_VALUE;
         LowerBuffer3[Bars-i]=EMPTY_VALUE;
         UpperBuffer4[Bars-i]=EMPTY_VALUE;
         LowerBuffer4[Bars-i]=EMPTY_VALUE;
        }
//----
   ArrayResize(MovingBuffer, Bars);
   ArraySetAsSeries(MovingBuffer,true);
   ArrayResize(ATRtemp, Bars);
   ArraySetAsSeries(ATRtemp,true);
   ArrayResize(ATR, Bars);
   ArraySetAsSeries(ATR,true);
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      MovingBuffer[i]=iMA(NULL,0,BandsPeriod,BandsShift,MODE_SMA,PRICE_CLOSE,i);
//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      double high=High[i];
      double low =Low[i];
      if(i==Bars-1) ATRtemp[i]=high-low;
      else
        {
         double prevclose=Close[i+1];
         ATRtemp[i]=MathMax(high,prevclose)-MathMin(low,prevclose);
        }
      i--;
     }
//----
   for(i=0; i<limit; i++)
      ATR[i]=iMAOnArray(ATRtemp,Bars,BandsPeriod,0,MODE_SMMA,i); //"default" ATR is MODE_SMA
//----
   i=Bars-BandsPeriod+1;
   if(counted_bars>BandsPeriod-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      deviation1=FibNumber1*ATR[i];
      deviation2=FibNumber2*ATR[i];
      deviation3=FibNumber3*ATR[i];
      deviation4=FibNumber4*ATR[i];
      UpperBuffer1[i]=MovingBuffer[i]+deviation1;
      LowerBuffer1[i]=MovingBuffer[i]-deviation1;
      UpperBuffer2[i]=MovingBuffer[i]+deviation2;
      LowerBuffer2[i]=MovingBuffer[i]-deviation2;
      UpperBuffer3[i]=MovingBuffer[i]+deviation3;
      LowerBuffer3[i]=MovingBuffer[i]-deviation3;
      UpperBuffer4[i]=MovingBuffer[i]+deviation4;
      LowerBuffer4[i]=MovingBuffer[i]-deviation4;
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+