//+------------------------------------------------------------------+
//|                                               BID_VIEW.mq4       |
//|                                      Copyright  2008, "OTCFX"   |
//|                                             Version 1.1                         |
//+------------------------------------------------------------------+

#property indicator_chart_window

  
  extern bool   Bid_Colors = True;
  extern int    FontSize=16;
  extern string FontType=" Sans MS";
  extern string note5 = "Display the price in what corner?";
  extern string note6 = "Upper left=0; Upper right=1";
  extern string note7 = "Lower left=2; Lower right=3";
  extern int    WhatCorner=0;
  
  double       Old_Price;
  double       Old_Price1;
  double       Old_Price2;
  int nDigits;
  color  ColorPrice = White;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
   
int init()
  {
   if(Symbol()=="GBPJPY" || Symbol()=="EURJPY" || Symbol()=="USDJPY" || Symbol()=="GOLD" || Symbol()=="USDMXN") nDigits = 2;
   if(Symbol()=="GBPUSD" || Symbol()=="EURUSD" || Symbol()=="NZDUSD" || Symbol()=="USDCHF"  ||
   Symbol()=="USDCAD" || Symbol()=="AUDUSD" || Symbol()=="EURUSD" || Symbol()=="EURCHF"  || Symbol()=="EURGBP"
   || Symbol()=="EURCAD" || Symbol()=="EURAUD" || Symbol()=="AUDNZD")nDigits = 4;
 
  
  
   return(0);
  }

int deinit()
  {
  ObjectDelete("M_P"); 
  ObjectDelete("MPI");             
  ObjectDelete("MPI1");
  ObjectDelete("MPI2");             
  ObjectDelete("MPI3");
  ObjectDelete("TKR"); 
  ObjectDelete("TKR1"); 
  
  
  return(0);
  }
  
 //+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+ 

int start()
  {
   
 int R77=0,CD=0;
  
  
   if (Bid_Colors == True)
   {
    if (Bid > Old_Price) ColorPrice = DodgerBlue;
    if (Bid < Old_Price) ColorPrice = LightGray;
    Old_Price = Bid;
   }
   
   color ColorCT709;
   if(  Bid  < Old_Price2    ) { ColorCT709 =Red; } 
   Old_Price2 = Bid;
    
   color ColorCT708;
   if(  Bid  > Old_Price1    ) { ColorCT708 =Lime; } 
   Old_Price1 = Bid;
      
  R77 =  (iClose(NULL,PERIOD_D1,0)-iClose(NULL,PERIOD_D1,1))/Point;
     
   string Market_Price = DoubleToStr(Bid, Digits);
   
   color ColorCH704 ;  
   if(  R77 >= 0 ) { ColorCH704 =LimeGreen ; } 
    color ColorCH705 ;  
   if(  R77 < 0 ) { ColorCH705 =Red ; } 
   
   ObjectCreate("TKR", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TKR",StringSubstr(Symbol(),0),12, "Arial Bold", CadetBlue);
   ObjectSet("TKR", OBJPROP_CORNER, WhatCorner);
   ObjectSet("TKR", OBJPROP_XDISTANCE, 37);
   ObjectSet("TKR", OBJPROP_YDISTANCE, 14);
   
    
   ObjectCreate("M_P", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("M_P", Market_Price , FontSize, FontType, ColorPrice);
   ObjectSet("M_P", OBJPROP_CORNER, WhatCorner);
   ObjectSet("M_P", OBJPROP_XDISTANCE, 36);
   ObjectSet("M_P", OBJPROP_YDISTANCE, 30);
   
        
   ObjectCreate("MPI",OBJ_LABEL,0,0,0);
   ObjectSetText("MPI","^", 21, "Arial Bold", ColorCT708);  
   ObjectSet("MPI",OBJPROP_CORNER,WhatCorner);
   ObjectSet("MPI",OBJPROP_ANGLE,360);
   ObjectSet("MPI", OBJPROP_XDISTANCE, 18);
   ObjectSet("MPI", OBJPROP_YDISTANCE, 14);
   
   ObjectCreate("MPI1",OBJ_LABEL,0,0,0);
   ObjectSetText("MPI1","^", 21, "Arial Bold", ColorCT709);  
   ObjectSet("MPI1",OBJPROP_CORNER,WhatCorner);
   ObjectSet("MPI1",OBJPROP_ANGLE,182);
   ObjectSet("MPI1", OBJPROP_XDISTANCE, 34);
   ObjectSet("MPI1", OBJPROP_YDISTANCE, 50);   
   
   
   ObjectCreate("MPI2",OBJ_LABEL,0,0,0);
   ObjectSetText("MPI2","^", 13, "Arial Bold", ColorCH704);  
   ObjectSet("MPI2",OBJPROP_CORNER,WhatCorner);
   ObjectSet("MPI2",OBJPROP_ANGLE,360);
   ObjectSet("MPI2", OBJPROP_XDISTANCE, 120);
   ObjectSet("MPI2", OBJPROP_YDISTANCE, 14);
   
   ObjectCreate("MPI3",OBJ_LABEL,0,0,0);
   ObjectSetText("MPI3","^", 13, "Arial Bold", ColorCH705);  
   ObjectSet("MPI3",OBJPROP_CORNER,WhatCorner);
   ObjectSet("MPI3",OBJPROP_ANGLE,182);
   ObjectSet("MPI3", OBJPROP_XDISTANCE, 130);
   ObjectSet("MPI3", OBJPROP_YDISTANCE, 40);
   
   ObjectCreate("TKR1", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("TKR1",DoubleToStr(R77,0),9, "Verdana Bold", Orange);
   ObjectSet("TKR1", OBJPROP_CORNER, WhatCorner);
   ObjectSet("TKR1", OBJPROP_XDISTANCE, 135);
   ObjectSet("TKR1", OBJPROP_YDISTANCE, 14);
        
  return(0);
  }  
   
   
  