//+------------------------------------------------------------------+
//|                                                         Bolt.mq4 |
//|                                  Copyright 2007, Ralph Ronnquist |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2007, Ralph Ronnquist"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LightGreen
#property indicator_color2 DarkOrange

double up[];
double dn[];

extern int range = 3;
extern int timeframe = 0; // Review time frame
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
    int index;

    IndicatorShortName( "Bolt(" + range + ")" );
    
    index = 0;
    SetIndexStyle( index, DRAW_ARROW );
    SetIndexBuffer( index, up );
    SetIndexLabel( index, "up" );
    SetIndexArrow( index, 233 );

    index = 1;
    SetIndexStyle( index, DRAW_ARROW );
    SetIndexBuffer( index, dn );
    SetIndexLabel( index, "dn" );
    SetIndexArrow( index, 234 );

    if ( timeframe == 0 )
        timeframe = Period();

    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
    for ( int bar = Bars - IndicatorCounted(); bar >= 0; bar-- ) {
        indicate( bar );
    }
    return(0);
}

// Compute the indication for given bar
void indicate(int bar) 
{
    up[ bar ] = EMPTY_VALUE;
    dn[ bar ] = EMPTY_VALUE;
    
    if ( isPeriodHigh( bar, range ) )
        up[ bar ] = High[ bar ] + range * Point;
    if ( isPeriodLow( bar, range ) )
        dn[ bar ] = Low[ bar ] - range * Point;
}

// Returns true if the high is highest amongst the previous "range" bars
bool isPeriodHigh(int bar,int range)
{
    int tfbar = iBarShift( Symbol(), timeframe, Time[ bar ], false );
    
    for (int i = 1; i < range; i++) {
        if ( High[ bar ] <= iHigh( Symbol(), timeframe, tfbar+i ) )
            return( false );
    }
    return( true );
}

// Returns true if the low is lowest amongst the previos "range" bars
bool isPeriodLow(int bar,int range)
{
    int tfbar = iBarShift( Symbol(), timeframe, Time[ bar ], false );

    for (int i = 1; i < range; i++) {
        if ( Low[ bar ] >= iLow( Symbol(), timeframe, tfbar+i ) )
            return( false );
    }
    return( true );
}


//+------------------------------------------------------------------+