//+------------------------------------------------------------------+
//|                                          CandleAggregator v5.mq4 |
//|                                                   David Louisson |
//| 2007.07.23                                      Revised by mason |
//+------------------------------------------------------------------+
#property copyright "David Louisson"
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 ForestGreen
#property indicator_color3 Red
#property indicator_color4 ForestGreen
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 5
#property indicator_width4 5

extern int      AggrFactor    = 2;         // how many candles to aggregate into a single candle
extern datetime BeginDateTime = D'2007.06.04 00:00:00';
extern int      VerticalShift = 0;
extern int      wingbar = 0;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//----
int CountedBars=0;
int BarBegin=0;
int BarMove=-1;
bool firsttime=true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
  
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM, 0, 1);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM, 0, 1);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM, 0, 5);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM, 0, 5);
   SetIndexBuffer(3, ExtMapBuffer4);
//----
   SetIndexDrawBegin(0,10);
   SetIndexDrawBegin(1,10);
   SetIndexDrawBegin(2,10);
   SetIndexDrawBegin(3,10);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);

   SetIndexLabel(0,"High/Low");
   SetIndexLabel(1,"High/Low");
   SetIndexLabel(2,"Open");
   SetIndexLabel(3,"Close");

   BarBegin=iBarShift(NULL,0,BeginDateTime,false);
   Comment("CA = ",DoubleToStr(AggrFactor,0)," Time = ",TimeToStr(BeginDateTime,TIME_MINUTES));

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  Comment("");
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i, p1, p2, count;
   double aggOpen, aggHigh, aggLow, aggClose,dpos;
   
   if(Bars<=10) return(0);
   CountedBars=IndicatorCounted();
//---- check for possible errors
   if (CountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (CountedBars>0) CountedBars--;
//   int pos=Bars-CountedBars-1;
   if (NewBar()) BarMove++;

if (firsttime) {
   int pos=BarBegin-AggrFactor+1;
   firsttime=false;
   while(pos>=-1)
     {
      p2 = pos+AggrFactor-1;                                // leftmost candle in group to be aggregated
      aggOpen  = Open[p2];                                  
      aggClose = Close[pos]+Point/5;                        // add 0.2 so that horiz line gets drawn for doji (force open != close)
      aggHigh  = 0;                                         // initialize with low value
      aggLow   = 9999;                                      // initialize with high value
      if (pos<=0) {
        aggHigh=MathMax(High[p2],High[0]);
        aggLow=MathMin(Low[p2],Low[0]);
        aggOpen  = Open[p2];                                  
        aggClose = Close[0]+Point/5;                        // add 0.2 so that horiz line gets drawn for doji (force open != close)
      }

      for (i=pos;i<=p2;i++)                                 // find highest and lowest price across candles to be aggregated
      {
        aggHigh=MathMax(High[i],aggHigh);
        aggLow=MathMin(Low[i],aggLow);
      }
       p1 = p2;                                            // p2 = leftmost candle in group
        if (aggOpen<aggClose) 
          {
           ExtMapBuffer1[p1]=aggLow+VerticalShift*Point;
           ExtMapBuffer2[p1]=aggHigh+VerticalShift*Point;
          } 
        else
          {
           ExtMapBuffer1[p1]=aggHigh+VerticalShift*Point;
           ExtMapBuffer2[p1]=aggLow+VerticalShift*Point;
          } 
        ExtMapBuffer3[p1]=aggOpen+VerticalShift*Point;
        ExtMapBuffer4[p1]=aggClose+VerticalShift*Point;
        if (wingbar!=0) {
           for (count=1;count<=wingbar;count++) {
               ExtMapBuffer3[p1+count]=aggOpen+VerticalShift*Point;
               ExtMapBuffer4[p1+count]=aggClose+VerticalShift*Point;
               ExtMapBuffer3[p1-count]=aggOpen+VerticalShift*Point;
               ExtMapBuffer4[p1-count]=aggClose+VerticalShift*Point;
           }
        }
        
 	   pos=pos-AggrFactor;
     } // while
} // if firsttime

      p2 = MathMod(BarBegin+BarMove,AggrFactor);      // leftmost candle in group to be aggregated
      aggOpen  = Open[p2];                                  
      aggClose = Close[0]+Point/5;                        // add 0.2 so that horiz line gets drawn for doji (force open != close)
      aggHigh  = 0;                                         // initialize with low value
      aggLow   = 9999;                                      // initialize with high value
      for (i=0;i<=p2;i++)                                 // find highest and lowest price across candles to be aggregated
      {
        aggHigh=MathMax(High[i],aggHigh);
        aggLow=MathMin(Low[i],aggLow);
      }
        p1 = p2;                                            // p2 = leftmost candle in group
        if (aggOpen<aggClose) 
          {
           ExtMapBuffer1[p1]=aggLow+VerticalShift*Point;
           ExtMapBuffer2[p1]=aggHigh+VerticalShift*Point;
          } 
        else
          {
           ExtMapBuffer1[p1]=aggHigh+VerticalShift*Point;
           ExtMapBuffer2[p1]=aggLow+VerticalShift*Point;
          } 
        ExtMapBuffer3[p1]=aggOpen+VerticalShift*Point;
        ExtMapBuffer4[p1]=aggClose+VerticalShift*Point;
        if (wingbar!=0) {
           for (count=1;count<=wingbar;count++) {
               ExtMapBuffer3[p1+count]=aggOpen+VerticalShift*Point;
               ExtMapBuffer4[p1+count]=aggClose+VerticalShift*Point;
               ExtMapBuffer3[p1-count]=aggOpen+VerticalShift*Point;
               ExtMapBuffer4[p1-count]=aggClose+VerticalShift*Point;
           }
        }

//----
   return(0);
  }
  
  
bool NewBar()
{
   static datetime dt = 0;
   
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}

//+------------------------------------------------------------------+